#!/usr/bin/perl
# $www_dir = "nil";  
$mwiki_addr = "mwiki\@localhost";

$latest_news_number = 5;

$main_title = "Contents";
$sub_title = "Contents of";
$index_title = "Index";

%sections = ();
# $sections_conf_file = '';

$main_body = "\n<h2>Welcome to mwiki</h2>\n<em>MAIL BASED CONTENT MANAGEMENT SYSTEM</em>\n";
$main_body_file = ''; # -> not present
$config_dir = "/fooooooooooo";

print_conf();
read_config_file("./read_config_file_mwiki.conf");
print_conf();
sub print_conf {
    print "--begin--\n";
    @config_variables = ( 'mwiki_addr',
			  'latest_news_number',
			  'main_title',
			  'sub_title',
			  'index_title',
			  'main_body_file',
			  'sections_conf_file',
			  'skin_dir',
			  'www_skin_dir' );
    foreach $var (@config_variables ) {
	print "$var = ${$var}\n";
    }
    print "--end--\n";
}
#### read config_file
sub read_config_file {
    my ($filename) = @_;

    if ($filename ne '' and -f $filename) {
	@config_variables = ( 'mwiki_addr',
			      'latest_news_number',
			      'main_title',
			      'sub_title',
			      'index_title',
			      'main_body_file',
			      'sections_conf_file',
			      'skin_dir',
			      'www_skin_dir' );
	@config_functions = ( 'generateHTML->read_skin',
			      'MailParser->AllowSimpleMail',
			      'MailParser->DoNotExpectMagicString' );

	open(SOURCE, "< $filename") or 
	    mdie(1, "ERROR: Can't open file \"$filename\" for reading.\n");
	my @file_content = <SOURCE>;
	close(SOURCE);

	foreach my $line (@file_content) {
	    foreach my $variable (@config_variables) {
		if ( $line =~ /^\$$variable\s*=\s*([^\n]*?)\s*;\s*$/i ) {
		    ( my $value = $1 ) =~ s/\"//g;
		    # expand variables - cf. the perlop manpage
		    $value =~ s/\$(\w+)/${$1}/g;
		    ${$variable} = $value;
		}
	    }
	    foreach my $function (@config_functions) {
		if ( $line =~ /^$function\(\s*([^\n]*?)\s*\)\s*;\s*$/i ) {
		    ( my $values = $1 ) =~ s/\"//g;
		    $function =~ /^(\w+)->(\w+)$/;
		    my $package = $1;
		    my $pkg_function = $2;
		    # print "function: $function, package: $package, pkg_function: $pkg_function, values: $values\n";
		    &{"${package}::${pkg_function}"}( $package, $values );
		}
	    }
	    # ignore lines that are not understood
	}
    }
    return 0;
}
package generateHTML;
sub read_skin {print "read_skin: >", join("--", @_), "<\n"; }
package MailParser;
sub AlowSimpleMail {print "AlowSimpleMail: >", join("--", @_), "<\n"; }
sub DoNotExpectMagicString {print "DoNotExpectMagicString: >", join("--", @_), "<\n"; }
